package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.ExcecaoGrupoContratoDAO;
import com.rjconsultores.ventaboletos.entidad.ExcecaoGrupoContrato;

@SuppressWarnings("unchecked")
@Repository("excecaoGrupoContratoDAO")
public class ExcecaoGrupoContratoHibernateDAO extends GenericHibernateDAO<ExcecaoGrupoContrato, Integer> implements ExcecaoGrupoContratoDAO {

    @Autowired
    public ExcecaoGrupoContratoHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

	@Override
    public List<ExcecaoGrupoContrato> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

        return c.list();
    }

	@Override
	public boolean gravarExcecoesGrupoContrato(List<ExcecaoGrupoContrato> excecoes) {

		for (ExcecaoGrupoContrato excecao : excecoes) {
			if(excecao.getExcecaoGrupoContratoId() == null) {
				suscribir(excecao);
			}else {
				actualizacion(excecao);
			}
		}

		return true;
	}
}
